#include <stdio.h>
#include "structs.h"
#include "protos.h"

extern struct s_object *objtable;
extern struct s_diagram *diagram;

extern FILE *yyin;

int yyparse();

void setinitialstates(struct s_action *act) {
	if(act) {
		if(act->msg) {
			if(act->msg->obj->state == OBJSTATE_BEINGBORN1)
				act->msg->obj->state =
					(act->msg->creation?
					OBJSTATE_UNBORN:
					OBJSTATE_INACTIVE);
		}
		setinitialstates(act->whathappen);
		setinitialstates(act->next);
	}
}

int main(int argc, char **argv) {
	struct s_object *optr;
	int eflag = 0;

	argc--; argv++;

	if(argc) {
		yyin = fopen(*argv, "r");
		if(!yyin) {
			perror("fopen");
			exit(2);
		}
	} else yyin = stdin;

	if(yyparse()) {
		exit(1);
	}

	for(optr = objtable; optr; optr = optr->tblnext) {
		if(optr->state == OBJSTATE_UNDEF) {
			fprintf(stderr, "%s used but not defined\n",
				optr->name);
			eflag = 1;
		}
		optr->state = OBJSTATE_BEINGBORN1;	/* should
					use something else, really */
	}
	if(eflag) exit(1);

	setinitialstates(diagram->seq);

	/*for(optr = objtable; optr; optr = optr->tblnext) {
		fprintf(stderr, "%d\n", optr->state);
	}*/

	draw();

	return 0;
}


